diff --git a/pki/base/common/src/com/netscape/cmscore/policy/GenericPolicyProcessor.java b/pki/base/common/src/com/netscape/cmscore/policy/GenericPolicyProcessor.java
index cdfb7025c70fe20c78222bab4939a3f556948152..7fbfb2db89af8d06b7739cecac72eb6fb798ca35 100644
--- a/pki/base/common/src/com/netscape/cmscore/policy/GenericPolicyProcessor.java
+++ b/pki/base/common/src/com/netscape/cmscore/policy/GenericPolicyProcessor.java
@@ -75,13 +75,13 @@ public class GenericPolicyProcessor implements IPolicyProcessor {
         {"com.netscape.cms.policy.constraints.ManualAuthentication"};
 
     // Policies that can't be deleted nor disabled.
-    public final static Hashtable DEF_UNDELETABLE_POLICIES = 
-        new Hashtable();
+    public final static Hashtable<String, IExpression> DEF_UNDELETABLE_POLICIES = 
+        new Hashtable<String, IExpression>();
 
     private String mId = "Policy";
-    private Vector mPolicyOrder = new Vector();
-    private Hashtable mImplTable = new Hashtable();
-    private Hashtable mInstanceTable = new Hashtable();
+    private Vector<String> mPolicyOrder = new Vector<String>();
+    private Hashtable<String, RegisteredPolicy> mImplTable = new Hashtable<String, RegisteredPolicy>();
+    private Hashtable<String, PolicyInstance> mInstanceTable = new Hashtable<String, PolicyInstance>();
     PolicySet mEnrollmentRules = new PolicySet("EnrollmentRules");
     PolicySet mRenewalRules = new PolicySet("RenewalRules");
     PolicySet mRevocationRules = new PolicySet("RevocationRules");
@@ -92,7 +92,7 @@ public class GenericPolicyProcessor implements IPolicyProcessor {
 
     // A Table of persistent policies and their predicates.
     // The predicates cannot be changed during configuration.
-    private Hashtable mUndeletablePolicies = null;
+    private Hashtable<String, IExpression> mUndeletablePolicies = null;
 
     public GenericPolicyProcessor() {
         mInitSystemPolicies = true; // CA & RA
@@ -208,7 +208,7 @@ public class GenericPolicyProcessor implements IPolicyProcessor {
         IConfigStore c;
 
         c = config.getSubStore(PROP_IMPL);
-        Enumeration mImpls = c.getSubStoreNames();
+        Enumeration<String> mImpls = c.getSubStoreNames();
 
         while (mImpls.hasMoreElements()) {
             String id = (String) mImpls.nextElement();
@@ -458,10 +458,10 @@ public class GenericPolicyProcessor implements IPolicyProcessor {
         return mAuthority.getId() + ".Policy";
     }
 
-    public Enumeration getPolicyImpls() {
-        Vector impls = new Vector();
-        Enumeration enum1 = mImplTable.elements();
-        Enumeration ret = null;
+    public Enumeration<IPolicyRule> getPolicyImpls() {
+        Vector<IPolicyRule> impls = new Vector<IPolicyRule>();
+        Enumeration<RegisteredPolicy> enum1 = mImplTable.elements();
+        Enumeration<IPolicyRule> ret = null;
 
         try {
             while (enum1.hasMoreElements()) {
@@ -481,10 +481,10 @@ public class GenericPolicyProcessor implements IPolicyProcessor {
         return ret;
     }
 
-    public Enumeration getPolicyImplsInfo() {
-        Vector impls = new Vector();
-        Enumeration enum1 = mImplTable.elements();
-        Enumeration ret = null;
+    public Enumeration<String> getPolicyImplsInfo() {
+        Vector<String> impls = new Vector<String>();
+        Enumeration<RegisteredPolicy> enum1 = mImplTable.elements();
+        Enumeration<String> ret = null;
 
         try {
             while (enum1.hasMoreElements()) {
@@ -518,15 +518,15 @@ public class GenericPolicyProcessor implements IPolicyProcessor {
         return impl;
     }
 
-    public Vector getPolicyImplConfig(String id) {
+    public Vector<String> getPolicyImplConfig(String id) {
         IPolicyRule rp = getPolicyImpl(id);
 
         if (rp == null)
             return null;
-        Vector v = rp.getDefaultParams();
+        Vector<String>  v = rp.getDefaultParams();
 
         if (v == null)
-            v = new Vector();
+            v = new Vector<String>();
         v.insertElementAt(IPolicyRule.PROP_ENABLE + "=" + "true", 0);
         v.insertElementAt(IPolicyRule.PROP_PREDICATE + "=" + " ", 1);
         return v;
@@ -544,7 +544,7 @@ public class GenericPolicyProcessor implements IPolicyProcessor {
 
             // If any instance exists for this impl, can't delete it.
         boolean instanceExist = false;
-        Enumeration e = mInstanceTable.elements();
+        Enumeration<PolicyInstance> e = mInstanceTable.elements();
 
         for (; e.hasMoreElements();) {
             PolicyInstance inst = (PolicyInstance) e.nextElement();
@@ -629,10 +629,10 @@ public class GenericPolicyProcessor implements IPolicyProcessor {
         }
     }
 
-    public Enumeration getPolicyInstances() {
-        Vector rules = new Vector();
-        Enumeration enum1 = mPolicyOrder.elements();
-        Enumeration ret = null;
+    public Enumeration<IPolicyRule> getPolicyInstances() {
+        Vector<IPolicyRule> rules = new Vector<IPolicyRule>();
+        Enumeration<String> enum1 = mPolicyOrder.elements();
+        Enumeration<IPolicyRule> ret = null;
 
         try {
             while (enum1.hasMoreElements()) {
@@ -649,17 +649,15 @@ public class GenericPolicyProcessor implements IPolicyProcessor {
         return ret;
     }
 
-    public Enumeration getPolicyInstancesInfo() {
-        Vector rules = new Vector();
-        Enumeration enum1 = mPolicyOrder.elements();
-        Enumeration ret = null;
+    public Enumeration<String> getPolicyInstancesInfo() {
+        Vector<String> rules = new Vector<String>();
+        Enumeration<String> enum1 = mPolicyOrder.elements();
+        Enumeration<String> ret = null;
 
         try {
             while (enum1.hasMoreElements()) {
-                String ruleName = (String) enum1.nextElement();
-                PolicyInstance instance =
-                    (PolicyInstance) mInstanceTable.get(ruleName);
-
+                String ruleName = enum1.nextElement();
+                PolicyInstance instance = mInstanceTable.get(ruleName);
                 rules.addElement(instance.getRuleInfo());
             }
             ret = rules.elements();
@@ -676,16 +674,16 @@ public class GenericPolicyProcessor implements IPolicyProcessor {
         return (policyInstance == null) ? null : policyInstance.getRule();
     }
 
-    public Vector getPolicyInstanceConfig(String id) {
+    public Vector<String> getPolicyInstanceConfig(String id) {
         PolicyInstance policyInstance = (PolicyInstance)
             mInstanceTable.get(id);
 
         if (policyInstance == null)
             return null;
-        Vector v = policyInstance.getRule().getInstanceParams();
+        Vector<String> v = policyInstance.getRule().getInstanceParams();
 
         if (v == null)
-            v = new Vector();
+            v = new Vector<String>();
         v.insertElementAt(PROP_IMPL_NAME + "=" + policyInstance.getImplId(), 0);
         v.insertElementAt(PROP_ENABLE + "=" + policyInstance.isActive(), 1);
         String predicate = " ";
@@ -757,7 +755,7 @@ public class GenericPolicyProcessor implements IPolicyProcessor {
         mInstanceTable.remove(id);
     }
 
-    public void addPolicyInstance(String id, Hashtable ht)
+    public void addPolicyInstance(String id, Hashtable<String, String> ht)
         throws EBaseException {
         // The instance id should be unique
         if (getPolicyInstance(id) != null)
@@ -780,9 +778,9 @@ public class GenericPolicyProcessor implements IPolicyProcessor {
             policyStore.getSubStore(PROP_RULE);
         IConfigStore newStore = instanceStore.makeSubStore(id);
 
-        for (Enumeration keys = ht.keys(); keys.hasMoreElements();) {
-            String key = (String) keys.nextElement();
-            String val = (String) ht.get(key);
+        for (Enumeration<String> keys = ht.keys(); keys.hasMoreElements();) {
+            String key = keys.nextElement();
+            String val =  ht.get(key);
 
             newStore.put(key, val);
         }
@@ -836,7 +834,7 @@ public class GenericPolicyProcessor implements IPolicyProcessor {
         addRule(id, rule);
     }
 
-    public void modifyPolicyInstance(String id, Hashtable ht)
+    public void modifyPolicyInstance(String id, Hashtable<String, String> ht)
         throws EBaseException {
         // The instance id should be there already
         PolicyInstance policyInstance = (PolicyInstance)
@@ -923,7 +921,7 @@ public class GenericPolicyProcessor implements IPolicyProcessor {
         ht.put(IPolicyRule.PROP_ENABLE, String.valueOf(active));
 
         // put old config store parameters first. 
-        for (Enumeration oldkeys = oldStore.keys(); 
+        for (Enumeration<String> oldkeys = oldStore.keys(); 
             oldkeys.hasMoreElements();) {
             String k = (String) oldkeys.nextElement();
             String v = (String) oldStore.getString(k);
@@ -932,7 +930,7 @@ public class GenericPolicyProcessor implements IPolicyProcessor {
         }
 
         // put modified params.
-        for (Enumeration newkeys = ht.keys(); 
+        for (Enumeration<String> newkeys = ht.keys(); 
             newkeys.hasMoreElements();) {
             String k = (String) newkeys.nextElement();
             String v = (String) ht.get(k);
@@ -973,7 +971,7 @@ public class GenericPolicyProcessor implements IPolicyProcessor {
 
             // Store the changes in the file.
         try {
-            for (Enumeration e = newStore.keys(); e.hasMoreElements();) {
+            for (Enumeration<String> e = newStore.keys(); e.hasMoreElements();) {
                 String key = (String) e.nextElement();
 
                 if (key != null) {
@@ -1022,7 +1020,7 @@ public class GenericPolicyProcessor implements IPolicyProcessor {
     public synchronized void changePolicyInstanceOrdering(
         String policyOrderStr)
         throws EBaseException {
-        Vector policyOrder = new Vector();
+        Vector<String> policyOrder = new Vector<String>();
         StringTokenizer tokens = new StringTokenizer(policyOrderStr, ",");
 
         // Get all the elements
@@ -1082,7 +1080,7 @@ public class GenericPolicyProcessor implements IPolicyProcessor {
         }
 
         // add rules specified in the new order.
-        for (Enumeration enum1 = policyOrder.elements();
+        for (Enumeration<String> enum1 = policyOrder.elements();
             enum1.hasMoreElements();) {
             String instanceName = (String) enum1.nextElement();
             PolicyInstance pInstance = (PolicyInstance)
@@ -1131,7 +1129,7 @@ public class GenericPolicyProcessor implements IPolicyProcessor {
         }
     }
 
-    private boolean areSameVectors(Vector v1, Vector v2) {
+    private boolean areSameVectors(Vector<String> v1, Vector<String> v2) {
         if (v1.size() != v2.size())
             return false;
         int size = v1.size();
@@ -1143,10 +1141,10 @@ public class GenericPolicyProcessor implements IPolicyProcessor {
         return (i == size ? true : false);
     }
 
-    private String getRuleOrderString(Vector rules) {
+    private String getRuleOrderString(Vector<String> rules) {
         StringBuffer sb = new StringBuffer();
 
-        for (Enumeration e = rules.elements(); e.hasMoreElements();) {
+        for (Enumeration<String> e = rules.elements(); e.hasMoreElements();) {
             sb.append((String) e.nextElement());
             sb.append(",");
         }
@@ -1155,7 +1153,7 @@ public class GenericPolicyProcessor implements IPolicyProcessor {
         return new String(sb);
     }
 
-    private String getRuleOrderString(Vector rules, String newRule) {
+    private String getRuleOrderString(Vector<String> rules, String newRule) {
         String currentRules = getRuleOrderString(rules);
 
         if (currentRules == null || currentRules.length() == 0)
@@ -1211,7 +1209,7 @@ public class GenericPolicyProcessor implements IPolicyProcessor {
             configuredDefaults.trim().length() == 0)
             mSystemDefaults = DEF_POLICIES;
         else {
-            Vector rules = new Vector();
+            Vector<String> rules = new Vector<String>();
             StringTokenizer tokenizer = new 
                 StringTokenizer(configuredDefaults.trim(), ",");
 	
@@ -1364,7 +1362,7 @@ public class GenericPolicyProcessor implements IPolicyProcessor {
             return;
         }
 
-        Vector rules = new Vector();
+        Vector<String> rules = new Vector<String>();
         StringTokenizer tokenizer = new 
             StringTokenizer(configuredUndeletables.trim(), ",");
 	
@@ -1381,8 +1379,8 @@ public class GenericPolicyProcessor implements IPolicyProcessor {
 
         // For each rule read from the config file, see if any 
         // predicate is set.
-        mUndeletablePolicies = new Hashtable();
-        for (Enumeration e = rules.elements(); e.hasMoreElements();) {
+        mUndeletablePolicies = new Hashtable<String, IExpression>();
+        for (Enumeration<String> e = rules.elements(); e.hasMoreElements();) {
             String urn = (String) e.nextElement();
 			
             // See if there is predicate in the file
@@ -1429,7 +1427,7 @@ public class GenericPolicyProcessor implements IPolicyProcessor {
         // For each policy in undeletable list make sure that
         // the policy is present, is not disabled and its predicate
         // is not tampered with.
-        for (Enumeration e = mUndeletablePolicies.keys(); 
+        for (Enumeration<String> e = mUndeletablePolicies.keys(); 
             e.hasMoreElements();) {
             String urn = (String) e.nextElement();
 
diff --git a/pki/base/common/src/com/netscape/cmscore/policy/PolicySet.java b/pki/base/common/src/com/netscape/cmscore/policy/PolicySet.java
index 17a19e9d49d12639564eca0fd3d0fd975ff4e6f9..24918a336f5af957a56de21a0e5c5d14f075020e 100644
--- a/pki/base/common/src/com/netscape/cmscore/policy/PolicySet.java
+++ b/pki/base/common/src/com/netscape/cmscore/policy/PolicySet.java
@@ -40,8 +40,8 @@ import com.netscape.cmscore.util.Debug;
  */
 public class PolicySet implements IPolicySet {
     private String mName;
-    private Vector mRuleNames = new Vector();
-    private Vector mRules = new Vector();
+    private Vector<String> mRuleNames = new Vector<String>();
+    private Vector<IPolicyRule> mRules = new Vector<IPolicyRule>();
     private ILogger mLogger = CMS.getLogger();
 
     public PolicySet(String name) {
@@ -140,7 +140,7 @@ public class PolicySet implements IPolicySet {
      *
      * @return An enumeration of rules.
      */
-    public Enumeration getRules() {
+    public Enumeration<IPolicyRule> getRules() {
         return mRules.elements();
     }
 
diff --git a/pki/base/common/src/com/netscape/cmscore/profile/ProfileSubsystem.java b/pki/base/common/src/com/netscape/cmscore/profile/ProfileSubsystem.java
index 3af3321d1ff42897ef3a2177dd890e1384d5b942..4f38625946041e3c9eff4cb74bf7d9053246f113 100644
--- a/pki/base/common/src/com/netscape/cmscore/profile/ProfileSubsystem.java
+++ b/pki/base/common/src/com/netscape/cmscore/profile/ProfileSubsystem.java
@@ -46,9 +46,9 @@ public class ProfileSubsystem implements IProfileSubsystem {
 
     private IConfigStore mConfig = null;
     private ISubsystem mOwner = null;
-    private Vector mProfileIds = new Vector();
-    private Hashtable mProfiles = new Hashtable();
-    private Hashtable mProfileClassIds = new Hashtable();
+    private Vector<String> mProfileIds = new Vector<String>();
+    private Hashtable<String, IProfile> mProfiles = new Hashtable<String, IProfile>();
+    private Hashtable<String, String> mProfileClassIds = new Hashtable<String, String>();
 
     /**
      * Retrieves the name of this subsystem.
@@ -106,7 +106,7 @@ public class ProfileSubsystem implements IProfileSubsystem {
             CMS.debug("Done Profile Creation - " + id);
         }
 
-        Enumeration ee = getProfileIds();
+        Enumeration<String> ee = getProfileIds();
 
         while (ee.hasMoreElements()) {
             String id = (String) ee.nextElement();
@@ -308,7 +308,7 @@ public class ProfileSubsystem implements IProfileSubsystem {
      * Retrieves a list of profile ids. The return
      * list is of type String.
      */
-    public Enumeration getProfileIds() {
+    public Enumeration<String> getProfileIds() {
         return mProfileIds.elements();
     }
 
diff --git a/pki/base/common/src/com/netscape/cmscore/registry/PluginRegistry.java b/pki/base/common/src/com/netscape/cmscore/registry/PluginRegistry.java
index cde61d6651ee2aa731fafe4497e1b8dd932e5f31..3e1c13fef795895cb1a498011db366076899cbde 100644
--- a/pki/base/common/src/com/netscape/cmscore/registry/PluginRegistry.java
+++ b/pki/base/common/src/com/netscape/cmscore/registry/PluginRegistry.java
@@ -44,7 +44,7 @@ public class PluginRegistry implements IPluginRegistry {
     private IConfigStore mConfig = null;
     private IConfigStore mFileConfig = null;
     private ISubsystem mOwner = null;
-    private Hashtable mTypes = new Hashtable();
+    private Hashtable<String, Hashtable <String ,IPluginInfo>> mTypes = new Hashtable<String, Hashtable<String, IPluginInfo>>();
 
     public PluginRegistry() {
     }
@@ -158,7 +158,7 @@ public class PluginRegistry implements IPluginRegistry {
 
     public void removePluginInfo(String type, String id)
         throws ERegistryException {
-        Hashtable plugins = (Hashtable)mTypes.get(type);
+        Hashtable<String, IPluginInfo> plugins = mTypes.get(type);
         if (plugins == null)
           return;
         plugins.remove(id);
@@ -173,10 +173,10 @@ public class PluginRegistry implements IPluginRegistry {
 
     public void addPluginInfo(String type, String id, IPluginInfo info, int saveConfig)
         throws ERegistryException {
-        Hashtable plugins = (Hashtable) mTypes.get(type); 
+        Hashtable<String, IPluginInfo> plugins =  mTypes.get(type); 
 
         if (plugins == null) {
-            plugins = new Hashtable();
+            plugins = new Hashtable<String, IPluginInfo>();
             mTypes.put(type, plugins);
         }
         Locale locale = Locale.getDefault();
@@ -192,7 +192,7 @@ public class PluginRegistry implements IPluginRegistry {
 
     public void rebuildConfigStore(Locale locale)
         throws ERegistryException {
-        Enumeration types = mTypes.keys();
+        Enumeration<String> types = mTypes.keys();
         StringBuffer typesBuf = new StringBuffer();
 
         while (types.hasMoreElements()) {
@@ -202,9 +202,9 @@ public class PluginRegistry implements IPluginRegistry {
             if (types.hasMoreElements()) {
                 typesBuf.append(",");
             }
-            Hashtable mPlugins = (Hashtable) mTypes.get(type);
+            Hashtable<String, IPluginInfo> mPlugins = mTypes.get(type);
             StringBuffer idsBuf = new StringBuffer();
-            Enumeration plugins = mPlugins.keys();
+            Enumeration<String> plugins = mPlugins.keys();
 
             while (plugins.hasMoreElements()) {
                 String id = (String) plugins.nextElement();
@@ -266,15 +266,15 @@ public class PluginRegistry implements IPluginRegistry {
     /**
      * Returns all type names.
      */
-    public Enumeration getTypeNames() {
+    public Enumeration<String> getTypeNames() {
         return mTypes.keys();
     }
 
     /**
      * Returns a list of identifiers of the given type.
      */
-    public Enumeration getIds(String type) {
-        Hashtable plugins = (Hashtable) mTypes.get(type);
+    public Enumeration<String> getIds(String type) {
+        Hashtable<String, IPluginInfo> plugins =  mTypes.get(type);
 
         if (plugins == null)
             return null;
@@ -285,11 +285,11 @@ public class PluginRegistry implements IPluginRegistry {
      * Retrieves the plugin information.
      */
     public IPluginInfo getPluginInfo(String type, String id) {
-        Hashtable plugins = (Hashtable) mTypes.get(type);
+        Hashtable <String ,IPluginInfo> plugins = mTypes.get(type);
 
         if (plugins == null)
             return null;
-        return (IPluginInfo) plugins.get(id);
+        return plugins.get(id);
     }
 
 }
diff --git a/pki/base/common/src/com/netscape/cmscore/request/ARequestQueue.java b/pki/base/common/src/com/netscape/cmscore/request/ARequestQueue.java
index 2da14467ecb746b7f3cd17d7c2947b6ed7a1896f..e7bc05f645d5b2f8492fc1b3a9386ef4ed76399f 100644
--- a/pki/base/common/src/com/netscape/cmscore/request/ARequestQueue.java
+++ b/pki/base/common/src/com/netscape/cmscore/request/ARequestQueue.java
@@ -830,7 +830,7 @@ class Request
      * this isn't that efficient but will do for now.
      */
     public void copyContents(IRequest req) {
-        Enumeration e = req.getExtDataKeys();
+        Enumeration<String> e = req.getExtDataKeys();
         while (e.hasMoreElements()) {
             String key = (String) e.nextElement();
             if (!key.equals(IRequest.ISSUED_CERTS) &&
@@ -858,11 +858,11 @@ class Request
                (! key.equals(""));
     }
 
-    protected boolean isValidExtDataHashtableValue(Hashtable hash) {
+    protected boolean isValidExtDataHashtableValue(Hashtable<String, String> hash) {
         if (hash == null) {
             return false;
         }
-        Enumeration keys = hash.keys();
+        Enumeration<String> keys = hash.keys();
         while (keys.hasMoreElements()) {
             Object key = keys.nextElement();
             if (! ((key instanceof String) &&
diff --git a/pki/base/common/src/com/netscape/cmscore/selftests/SelfTestSubsystem.java b/pki/base/common/src/com/netscape/cmscore/selftests/SelfTestSubsystem.java
index ba3a8d550680b38df71db2f258d3df1d54e03eb7..8104210d946f61b83506673f4b221c768503cf97 100644
--- a/pki/base/common/src/com/netscape/cmscore/selftests/SelfTestSubsystem.java
+++ b/pki/base/common/src/com/netscape/cmscore/selftests/SelfTestSubsystem.java
@@ -275,7 +275,7 @@ public class SelfTestSubsystem
 
         // loop through all self test plugin instances
         // specified to be executed on demand
-        Enumeration instances = mOnDemandOrder.elements();
+        Enumeration<SelfTestOrderedInstance> instances = mOnDemandOrder.elements();
 
         int i = 0;
 
@@ -320,7 +320,7 @@ public class SelfTestSubsystem
 
         // loop through all self test plugin instances
         // specified to be executed on demand
-        Enumeration instances = mOnDemandOrder.elements();
+        Enumeration<SelfTestOrderedInstance> instances = mOnDemandOrder.elements();
 
         while (instances.hasMoreElements()) {
             SelfTestOrderedInstance instance = (SelfTestOrderedInstance)
@@ -382,7 +382,7 @@ public class SelfTestSubsystem
 
         // loop through all self test plugin instances
         // specified to be executed on demand
-        Enumeration instances = mOnDemandOrder.elements();
+        Enumeration<SelfTestOrderedInstance> instances = mOnDemandOrder.elements();
 
         while (instances.hasMoreElements()) {
             SelfTestOrderedInstance instance = (SelfTestOrderedInstance)
@@ -427,7 +427,7 @@ public class SelfTestSubsystem
 
         // loop through all self test plugin instances
         // specified to be executed on demand
-        Enumeration instances = mOnDemandOrder.elements();
+        Enumeration<SelfTestOrderedInstance> instances = mOnDemandOrder.elements();
 
         while (instances.hasMoreElements()) {
             SelfTestOrderedInstance instance = (SelfTestOrderedInstance)
@@ -471,7 +471,7 @@ public class SelfTestSubsystem
 
         // loop through all self test plugin instances
         // specified to be executed on demand
-        Enumeration instances = mOnDemandOrder.elements();
+        Enumeration<SelfTestOrderedInstance> instances = mOnDemandOrder.elements();
 
         while (instances.hasMoreElements()) {
             SelfTestOrderedInstance instance = (SelfTestOrderedInstance)
@@ -511,7 +511,7 @@ public class SelfTestSubsystem
 
         // loop through all self test plugin instances
         // specified to be executed on demand
-        Enumeration instances = mOnDemandOrder.elements();
+        Enumeration<SelfTestOrderedInstance> instances = mOnDemandOrder.elements();
 
         while (instances.hasMoreElements()) {
             SelfTestOrderedInstance instance = (SelfTestOrderedInstance)
@@ -600,7 +600,7 @@ public class SelfTestSubsystem
 
         // loop through all self test plugin instances
         // specified to be executed at server startup
-        Enumeration instances = mStartupOrder.elements();
+        Enumeration<SelfTestOrderedInstance> instances = mStartupOrder.elements();
 
         int i = 0;
 
@@ -645,7 +645,7 @@ public class SelfTestSubsystem
 
         // loop through all self test plugin instances
         // specified to be executed at server startup
-        Enumeration instances = mStartupOrder.elements();
+        Enumeration<SelfTestOrderedInstance> instances = mStartupOrder.elements();
 
         while (instances.hasMoreElements()) {
             SelfTestOrderedInstance instance = (SelfTestOrderedInstance)
@@ -707,7 +707,7 @@ public class SelfTestSubsystem
 
         // loop through all self test plugin instances
         // specified to be executed at server startup
-        Enumeration instances = mStartupOrder.elements();
+        Enumeration<SelfTestOrderedInstance> instances = mStartupOrder.elements();
 
         while (instances.hasMoreElements()) {
             SelfTestOrderedInstance instance = (SelfTestOrderedInstance)
@@ -753,7 +753,7 @@ public class SelfTestSubsystem
 
         // loop through all self test plugin instances
         // specified to be executed at server startup
-        Enumeration instances = mStartupOrder.elements();
+        Enumeration<SelfTestOrderedInstance> instances = mStartupOrder.elements();
 
         while (instances.hasMoreElements()) {
             SelfTestOrderedInstance instance = (SelfTestOrderedInstance)
@@ -797,7 +797,7 @@ public class SelfTestSubsystem
 
         // loop through all self test plugin instances
         // specified to be executed at server startup
-        Enumeration instances = mStartupOrder.elements();
+        Enumeration<SelfTestOrderedInstance> instances = mStartupOrder.elements();
 
         while (instances.hasMoreElements()) {
             SelfTestOrderedInstance instance = (SelfTestOrderedInstance)
@@ -846,7 +846,7 @@ public class SelfTestSubsystem
 
             // loop through all self test plugin instances
             // specified to be executed at server startup
-            Enumeration instances = mStartupOrder.elements();
+            Enumeration<SelfTestOrderedInstance> instances = mStartupOrder.elements();
 
             while (instances.hasMoreElements()) {
                 SelfTestOrderedInstance instance = (SelfTestOrderedInstance)
@@ -980,7 +980,7 @@ public class SelfTestSubsystem
         }
 
         // loop through all self test plugin instances
-        Enumeration instances = mSelfTestInstances.elements();
+        Enumeration<ISelfTest> instances = mSelfTestInstances.elements();
 
         while (instances.hasMoreElements()) {
             ISelfTest instance = (ISelfTest) instances.nextElement();
@@ -1355,7 +1355,7 @@ public class SelfTestSubsystem
             throw new EMissingSelfTestException();
         }
 
-        Enumeration loggerInstances = loggerConfig.getPropertyNames();
+        Enumeration<String> loggerInstances = loggerConfig.getPropertyNames();
 
         if (loggerInstances.hasMoreElements()) {
             loadStatus++;
@@ -1495,7 +1495,7 @@ public class SelfTestSubsystem
             throw new EMissingSelfTestException();
         }
 
-        Enumeration instances = instanceConfig.getPropertyNames();
+        Enumeration<String> instances = instanceConfig.getPropertyNames();
 
         if (instances.hasMoreElements()) {
             loadStatus++;
@@ -1842,7 +1842,7 @@ public class SelfTestSubsystem
     public void startup()
         throws EBaseException {
         // loop through all self test plugin instances
-        Enumeration instances = mSelfTestInstances.elements();
+        Enumeration<ISelfTest> instances = mSelfTestInstances.elements();
 
         while (instances.hasMoreElements()) {
             ISelfTest instance = (ISelfTest) instances.nextElement();
@@ -1852,7 +1852,7 @@ public class SelfTestSubsystem
 
         if (!CMS.isPreOpMode()) {
             // run all self test plugin instances (designated at startup)
-            Enumeration selftests = mStartupOrder.elements();
+            Enumeration<SelfTestOrderedInstance> selftests = mStartupOrder.elements();
 
             if (selftests.hasMoreElements()) {
                 // log that execution of startup self tests has begun
@@ -1883,13 +1883,13 @@ public class SelfTestSubsystem
      */
     public void shutdown() {
         // reverse order of all self test plugin instances
-        Collection  collection = mSelfTestInstances.values();
-        Vector list = new Vector(collection);
+        Collection<ISelfTest>  collection = mSelfTestInstances.values();
+        Vector<ISelfTest> list = new Vector<ISelfTest>(collection);
 
         Collections.reverse(list);
 
         // loop through all self test plugin instances
-        ListIterator instances = list.listIterator();
+        ListIterator<ISelfTest> instances = list.listIterator();
 
         while (instances.hasNext()) {
             ISelfTest instance = (ISelfTest) instances.next();
diff --git a/pki/base/common/src/com/netscape/cmscore/usrgrp/Group.java b/pki/base/common/src/com/netscape/cmscore/usrgrp/Group.java
index 40f3281eed5173fd3dfe43b51dde6b8dd58aad68..d91eedf93a4f2d34983a5bae555207afd7641258 100644
--- a/pki/base/common/src/com/netscape/cmscore/usrgrp/Group.java
+++ b/pki/base/common/src/com/netscape/cmscore/usrgrp/Group.java
@@ -40,10 +40,10 @@ public class Group implements IGroup {
     private static final long serialVersionUID = -1264387079578766750L;
     private IUsrGrp mBase = null;
     private String mName = null;
-    private Vector mMembers = new Vector();
+    private Vector<String> mMembers = new Vector<String>();
     private String mDescription = null;
 
-    private static final Vector mNames = new Vector();
+    private static final Vector<String> mNames = new Vector<String>();
     static {
         mNames.addElement(ATTR_NAME);
         mNames.addElement(ATTR_ID);
@@ -75,7 +75,7 @@ public class Group implements IGroup {
         mMembers.addElement(name);
     }
 
-    public Enumeration getMemberNames() {
+    public Enumeration<String> getMemberNames() {
         return mMembers.elements();
     }
 
@@ -90,13 +90,14 @@ public class Group implements IGroup {
         return false;
     }
 
-    public void set(String name, Object object) throws EBaseException {
+    @SuppressWarnings("unchecked")
+	public void set(String name, Object object) throws EBaseException {
         if (name.equals(ATTR_NAME)) {
             throw new EBaseException(CMS.getUserMessage("CMS_BASE_INVALID_ATTRIBUTE", name));
         } else if (name.equals(ATTR_ID)) {
             throw new EBaseException(CMS.getUserMessage("CMS_BASE_INVALID_ATTRIBUTE", name));
         } else if (name.equals(ATTR_MEMBERS)) {
-            mMembers = (Vector) object;
+            mMembers = (Vector<String>) object;
         } else if (name.equals(ATTR_DESCRIPTION)) {
             mDescription = (String) object;
         } else {
@@ -120,7 +121,7 @@ public class Group implements IGroup {
         throw new EBaseException(CMS.getUserMessage("CMS_BASE_INVALID_ATTRIBUTE", name));
     }
 
-    public Enumeration getElements() {
+    public Enumeration<String> getElements() {
         return mNames.elements();
     }
 }
